#include "regs.h"

.set IMMR,      638

.set BR0,       0x0100
.set BR1,       0x0108
.set BR2,       0x0110
.set BR3,       0x0118

.set BRGC1,     0x09f0

.set SICR,      0x0aec

.set CICR,0x0940
.set CIPR,0x0944
.set CIMR,0x0948

.set SIMODE,0x0ae0
.set SDCR,0x0030

.set CPCR,0x09c0

.set PBPAR,0x0abc
.set PBDIR,0x0ab8
.set PBODR,0x0ac2

.set PCPAR,0x0962
.set PCDIR,0x0960
.set PCSO,0x0964

.set SMC1RBAS,0x3e80+0x00
.set SMC1TBAS,0x3e80+0x02
.set SMC1RFCR,0x3e80+0x04
.set SMC1TFCR,0x3e80+0x05
.set SMC1MRBL,0x3e80+0x06
.set SMC1RBPTR,0x3e80+0x10
.set SMC1TBPTR,0x3e80+0x20
.set SMC1MAXI,0x3e80+0x28
.set SMC1BRKL,0x3e80+0x2c
.set SMC1BRKE,0x3e80+0x2e
.set SMC1BRKC,0x3e80+0x30

.set SMC1MR,0x0a82
.set SMC1E,0x0a86
.set SMC1M,0x0a8a

.set DC_CST,568
.set IC_CST,560

.set DCacheEnableCmd,0x0200
.set CacheEnableBit,0x8000
.set CacheDisableCmd,0x0400

.set PLPRCR,0x0284
#Changed from initial values ASK LAN

.set Rxbd,0x2000
.set Txbd,0x2008
.set Rxbuf,0x2010
.set Txbuf,0x2014
#define FA(x) (x-start)

.globl _start
_start:

bl start
start:
mflr r29

bl init_serial

li  r3, FA(Sinit)
add r3, r3, r29
bl serial_puts

lis r5, 0x1001
ori r5, r5, 0x4A88
lwz r3, 0(r5)
lis r4, 0x312E
ori r4, r4, 0x3200
cmp 0, 1, r3, r4
lis r9, 0x1000
ori r9, r9, 0x095C
beq vOK
lis r5, 0x1001
ori r5, r5, 0x46C8
lwz r3, 0(r5)
lis r4, 0x312E
ori r4, r4, 0x3000
cmp 0, 1, r3, r4
lis r9, 0x1000
ori r9, r9, 0x944
beq vOK

li  r3, FA(Sunknown)
add r3, r3, r29
bl serial_puts

b hang

vOK:

mr r3, r5
bl serial_puts

li  r3, FA(Saddress)
add r3, r3, r29
bl serial_puts
mr  r3, r9
mr  r10, r9
bl dump_hex
mr  r9, r10

li r3, FA(Scstate)
add r3, r3, r29
bl serial_puts

lwz r3, 0(r9)
li r4, 0
cmp 0, 1, r3, r4
beq vUnlocked
lis r4, 0xFFFF
ori r4, r4, 0xFFFF
cmp 0, 1, r3, r4
beq vLocked
lis r4, 0xFFFF
cmp 0, 1, r3, r4
beq vHLocked

bl dump_hex

li r3, FA(Sslocked)
vPrint:
add r3, r3, r29
bl serial_puts
b hang

vUnlocked:
li r3, FA(Sunlocked)
b vPrint

vHLocked:
li r3, FA(Shlocked)
add r3, r3, r29
bl serial_puts

vLocked:
li r3, FA(Slocked)
add r3, r3, r29
bl serial_puts

li r3, FA(Sdetflash)
add r3, r3, r29
bl serial_puts

lis r8, 0x1000

lis r3, 0x98
ori r3, r3, 0x98
eieio
stw r3, 0(r8)
eieio

lwz r3, 0x40(r8)
lis r4, 'Q'
ori r4, r4, 'Q'
cmp 0, 1, r3, r4
li  r3, FA(Sfailed)
bne vPrint

lwz r3, 0x44(r8)
lis r4, 'R'
ori r4, r4, 'R'
cmp 0, 1, r3, r4
li  r3, FA(Sfailed)
bne vPrint


lwz r3, 0x48(r8)
lis r4, 'Y'
ori r4, r4, 'Y'
cmp 0, 1, r3, r4
li  r3, FA(Sfailed)
bne vPrint

lwz r3, 0x0(r8)
lis r4, 0x89
ori r4, r4, 0x89
cmp 0, 1, r3, r4
li  r3, FA(Sother)
bne vPrint

li  r3, FA(Sintel)
add r3, r3, r29
bl serial_puts

li  r3, FA(Sunprotect)
add r3, r3, r29
bl serial_puts

lis r3, 0x50
ori r3, r3, 0x50                // clear status register
eieio
stw r3, 0(r9)
eieio

lis r3, 0x60
ori r3, r3, 0x60                // configuration set-up
eieio
stw r3, 0(r9)
eieio

lis r3, 0xD0
ori r3, r3, 0xD0                // unlock block
eieio
stw r3, 0(r9)
eieio

bl checkstatus

li  r3, FA(Sok)
add r3, r3, r29
bl serial_puts

li  r3, FA(Sprog)
add r3, r3, r29
bl serial_puts

lis r3, 0x40
ori r3, r3, 0x40                // program set-up
eieio
stw r3, 0(r9)
eieio

lis r3, 0
ori r3, r3, 0                   // write!
eieio
stw r3, 0(r9)
eieio

lis r4, 76
mtctr r4

lis r4, 0x80
ori r4, r4, 0x80

wait_loop:
lwz r3, 0(r9)
and r3, r3, r4
cmp 0, 1, r3, r4
beq vSOK
bdnz wait_loop

li  r3, FA(Stimeout)
add r3, r3, r29
bl serial_puts

vSOK:

bl checkstatus

lis r3, 0xFF
ori r3, r3, 0xFF                // read array
eieio
stw r3, 0(r9)
eieio

lwz r3, 0(r9)
li  r4, 0
cmp 0, 1, r3, r4
beq vDone

li  r3, FA(Swrongdata)
add r3, r3, r29
bl serial_puts

lwz r3, 0(r9)
bl dump_hex

li  r3, FA(Ssorry)
add r3, r3, r29
bl serial_puts

b hang

vDone:

li  r3, FA(Sdone)
add r3, r3, r29
bl serial_puts

hang:
b hang

checkstatus:
lis r3, 0x70
ori r3, r3, 0x70                // read status register
eieio
stw r3, 0(r9)
eieio
lwz r3, 0(r9)
lis r4, 0x80
ori r4, r4, 0x80
cmp 0, 1, r3, r4
beqlr
bl dump_hex
li r3, FA(Ssfailed)
b  vPrint

// reset durch watchdog !?
li r15, 0x0000
li r14, -1              #set all bits
stb r14, SMC1E(r3)      #Clear any pending interrupts
stb r15, SMC1M(r3)      #Mask all interrupts, use polling mode
stw r15, CICR(r3)       #Disable all CPM interrupts
stw r14, CIPR(r3)       #Clear all pending interrupt events
stw r15, CIMR(r3)       #Mask all event interrupts

blr

dump_hex:
mr r6, r3               // r6: value
li r7, 32               // r7: cnt
li r5, 0xF              // r5: mask
li r8, -4
li r9, 10
oris r8, r8, 0xFFFF
next_digit:
  subi r7, r7, 4        // cnt-=4;
  cmp 0, 1, r7, r8
  beqlr
  sraw r3, r6, r7       // r3=value>>cnt;
  and  r3, r3, r5       // r3&=0xF;
  cmp  0, 1, r3, r9
  blt ok
  addi r3, r3, 'A'-0xA-0x30
ok:
  addi r3, r3, 0x30     // r3|=0x30 
  
  mflr r28
  bl serial_outc
  mtlr r28
  b next_digit

init_serial:
// load IMMR to r3
mfspr r3,IMMR
andis. r3,r3,0xffff

lwz r14, BR1(r3)        #/* Load the contents of BR1 */

addis r15, r0, 0xFFFF   #/*Load mask to strip 17 bits of BR1 */
ori r15, r15, 0x8000    #/*Load mask to strip 17 bits of BR1 */

and r14,r15,r14         #/* Keep bits 0 to 17 of BR1 */
                        #/* R5 now points to the starting address of the
                        #/* BCSR's.  The Irda LED is in BCSR1 */

lwz r15, 4(r14)         #/* Load the contents of BCSR1 */
andis. r15, r15, 0xfeff #Enable the RS232-1-EN bit (active low)
stw r15, 4(r14)         #Put it back into BCSR

//li r15, -0x7fff         #Load the CPM reset word
//sth r15, CPCR(r3)       #Write it to the CPM register

li r15, 0x00d0          #Setup port B
stw r15, PBPAR(r3)

li r15, 0x0000
stw r15, PBDIR(r3)
sth r15, PBODR(r3)

lis r14, 0x0001         #Set up 38.4k at ??MHz

//ori r14, r14, 0x00D0  # 38400
ori r14, r14, 0x008E    # 57600

stw r14, BRGC1(r3)      #Write to BRG config

sth r15, SICR(r3)       #All SCC Tx/Rx clock from BRG1

sth r15, SDCR(r3)       #SDMA and LCD bus request level 6

stw r15, SIMODE(r3)     #NMSI mode, BRG1 to SMC1

li r14, Rxbd
sth r14, SMC1RBAS(r3)   #Set RXBD tbl start at Dual Port + 2000

li r14, Txbd
sth r14, SMC1TBAS(r3)   #Set TXBD tbl start at Dual Port + 2004

li r14, 0x0091          #Init Rx and Tx params for SMC1
sth r14, CPCR(r3)       #Do it

li r14, 0x0018
stb r14, SMC1RFCR(r3)
stb r14, SMC1TFCR(r3)

#Protocol specific parameters

li r14, 0x0001
sth r14, SMC1MRBL(r3)   #Max receive buffer length

li r15, 0x0000
sth r15, SMC1MAXI(r3)   #Disable max_idle feature

sth r15, SMC1BRKL(r3)   #no last brk char received
sth r15, SMC1BRKE(r3)   #no brake condition occurred

sth r15, SMC1BRKC(r3)   #1 break char sent on top XMIT

#Program RXBD

sth	r15, Rxbd+2(r3) #Init length to 0
addi r14, r3, Rxbuf     #Address of Rxbuf
stw r14, Rxbd+4(r3)     #Store it into bd
li r14, -0x6000          #Empty, wrap, no interrupt
sth r14, Rxbd(r3)       #Do this last so Bd ready when done

#Program TXBD

li r14, 0x0001          #Init length to 1
sth r14, Txbd+2(r3)     #Store it
addi r14, r3, Txbuf     #Address of Txbuf
stw r14, Txbd+4(r3)     #Store it
li r14, 0x2000          #Not ready to send, wrap, no interrupt
sth r14, Txbd(r3)       #Do this last so Bd ready when done

#Enable SMC for action

//li r14, -1              #set all bits
//stb r14, SMC1E(r3)      #Clear any pending interrupts

//stb r15, SMC1M(r3)      #Mask all interrupts, use polling mode

//stw r15, CICR(r3)       #Disable all CPM interrupts
//stw r14, CIPR(r3)       #Clear all pending interrupt events
//stw r15, CIMR(r3)       #Mask all event interrupts

li  r14, 0x4820         #Normal operation, 8 bit, no parity, 1 stop bit
sth r14, SMC1MR(r3)     #Store it before turning on

li  r14, 0x4823         #Enable transmit and receive
sth r14, SMC1MR(r3)     #Store it
blr

serial_outc:
mfspr r4, IMMR
andis. r4, r4, 0xFFFF
w_loop:
// Daten seriell ausgeben
lhz r14, Txbd(r4)       #Read Txbd
andi. r14,r14, 0x8000   #Test bit 0
bne w_loop    #Loop because bd not freed up yet

lwz r15, Txbd+4(r4)     #Load location of buffer
stb r3, 0(r15)          #Store byte at beginning of Tx buffer
li	r14, 0x5000     #Tell SMC1 to xmit
addi    r14,r14,0x5000
eieio
sth r14, Txbd(r4)       #Write the new Txbd
eieio
blr

serial_puts:
li r6, 0
subi r5, r3, 1
puts_loop:
   lbzu r3, 1(r5)
   cmp 0, 1, r3, r6
   beqlr
   mflr r28
   bl serial_outc
   mtlr 28
b puts_loop
blr

Sinit:      .ascii "\r\n\n\nDebugEnabler (c) tmbinc, gillem\r\n"
            .ascii "bl-version      : \0"
Sunknown:   .ascii "unknown, please report\0"
Scstate:    .ascii "\r\ncurrent state   : \0"
Slocked:    .ascii "locked\0"
Shlocked:   .ascii "tmb-\0"
Sunlocked:  .ascii "unlocked\0"
Sslocked:   .ascii " - that's strange!\0"
Saddress:   .ascii "\r\ndiag-switch? at : \0"
Sdetflash:  .ascii "\r\nflashrom type   : \0"
Sintel:     .ascii "INTEL\0"
Sother:     .ascii "OTHER - sorry :(\0"
Sunprotect: .ascii "\r\nunprotecting    : \0"
Ssfailed:   .ascii " - "
Sfailed:    .ascii "FAILED!!!\r\n\0"
Sok:        .ascii "OK!\0"
Swrongdata: .ascii "COULDN'T WRITE, IT'S STLL \0"
Ssorry:     .ascii "\r\nSorry about that.\r\n\0"
Sprog:      .ascii "\r\nflashing NOW    : \0"
Sdone:      .ascii "Done!\r\n\0"
Stimeout:   .ascii "TIMEOUT.\r\n\0"
